<?php


function _convert($content) {
// From http://www.php.net/manual/en/function.utf8-encode.php
  
    if(!mb_check_encoding($content, 'UTF-8') 
        OR !($content === mb_convert_encoding(mb_convert_encoding($content, 'UTF-32', 'UTF-8' ), 'UTF-8', 'UTF-32'))) { 

        $content = mb_convert_encoding($content, 'UTF-8'); 

        if (mb_check_encoding($content, 'UTF-8')) { 
            // log('Converted to UTF-8'); 
        } else { 
            // log('Could not converted to UTF-8'); 
        } 
    } 
    return $content; 
} 

function unhtmlentities($string)
{
    // replace numeric entities
    $string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
    $string = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $string);
    // replace literal entities
    $trans_tbl = get_html_translation_table(HTML_ENTITIES);
    $trans_tbl = array_flip($trans_tbl);
    return strtr($string, $trans_tbl);
}


function uniord($c) {
    $h = ord($c{0});
    if ($h <= 0x7F) {
        return $h;
    } else if ($h < 0xC2) {
        return false;
    } else if ($h <= 0xDF) {
        return ($h & 0x1F) << 6 | (ord($c{1}) & 0x3F);
    } else if ($h <= 0xEF) {
        return ($h & 0x0F) << 12 | (ord($c{1}) & 0x3F) << 6
                                 | (ord($c{2}) & 0x3F);
    } else if ($h <= 0xF4) {
        return ($h & 0x0F) << 18 | (ord($c{1}) & 0x3F) << 12
                                 | (ord($c{2}) & 0x3F) << 6
                                 | (ord($c{3}) & 0x3F);
    } else {
        return false;
    }
}

  $userIP = $_SERVER['REMOTE_ADDR'];
  
//  echo $userIP ."<br /><br />";

  $langSource = $_REQUEST['langSource'];
  $langTarget = $_REQUEST['langTarget'];
  $langText   = $_REQUEST['langText'];

  $key = file_get_contents("/bah / blah / bah .txt"); // path obscured
  
  $sendThis = "https://www.googleapis.com/language/translate/v2?".
                 "prettyprint=true".
                 "&key=$key".
                 "&source=$langSource".	
                 "&target=$langTarget".
                 "&q=" . urlencode($langText) .
                 "&userip=" . $userIP
                 ;
  
//   echo $sendThis . "<br /><br />";
  // echo file_get_contents($sendThis);
  
 $ch = curl_init();

// set URL and other appropriate options
curl_setopt($ch, CURLOPT_URL, $sendThis);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  // stops echo of result and allows to be captured in a variable
curl_setopt($ch, CURLOPT_HEADER, 0);

// work around for utf-8 here

header('Content-Type: text/html; charset=utf-8');

// grab URL and pass it to the browser



   $returned =  @curl_exec($ch);

 
  // do everything to it!
 	 $returned =  _convert(html_entity_decode(htmlspecialchars_decode(urldecode($returned)), ENT_COMPAT, "UTF-8")); //  ENT_COMPAT
 
// close cURL resource, and free up system resources
curl_close($ch);  
 
 echo $returned;
 
 
  /*
  Dual licensed under the

GPL (http://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

Copyright (c) 2010,2011 Paul A Norman and others in their own right


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

MIT (http://www.opensource.org/licenses/mit-license.php)

Copyright (c) 2010,2011 Paul A Norman and others in their own right

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal in the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL PAUL ANTHONY NORMAN BE LIABLE FOR ANY CLAIM, DAMAGES
 OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN EITHER THE SOFTWARE OR DOCUMENTATION.

*/
 
/* // Was wanting to send Utf-8 codes - a more genreic corss OS solution let TeXworks handle final conversion back to utf-8 chars

      $process = str_split($returned);
    
    $build = "";
   
     foreach($process as $cc)
       {
         
         $ccu = uniord($cc);
         
         if ($ccu != "")
          {
           $build .= $ccu .", " ;  // safe for transport basically any where through anything! - letting TwScript handle the reconversion to utf-8 
           }      
        }

   $build = substr($build, 0, strlen($build) -2);  // get rid of trailing comma

echo $build;
  */
?>